﻿package object3ds.flashGUI 
{
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	//Flashコンポーネント
	import fl.controls.Slider;
	import fl.controls.Button;
	import fl.controls.Label;
	import fl.events.SliderEvent;
	
	import org.papervision3d.cameras.Camera3D;	
	import org.papervision3d.objects.DisplayObject3D;
	
	import caurina.transitions.Tweener; 
	
	/**
	 * ...
	 * @author hagiwara
	 */
	public class CameraConPane extends conPaneS
	{
		private var camera:Camera3D
		
		private var defaultCameraX:int;
		private var defaultCameraY:int;
		private var defaultCameraZ:int;
		private var defaultCameraZoom:int;
		
		private var defaultCameraTargetX:int;
		private var defaultCameraTargetY:int;
		private var defaultCameraTargetZ:int;
		
		private var sliderX:Slider;
		private var sliderY:Slider;
		private var sliderZ:Slider;
		
		private var sliderLabelMarginX:int = 10;
		private var sliderLabelMarginY:int = 30;
		private var sliderMarginX:int = 50;
		private var sliderMarginY:int = 7;
		
		public function CameraConPane() 
		{
			super();
			this.x = 10
			this.y = 400;
			
			// カメラの作成とカメラ座標の設定
			this.camera = new Camera3D();
			this.camera.x = this.defaultCameraX = 0;
			this.camera.y = this.defaultCameraY = 300;
			this.camera.z = this.defaultCameraZ = 1000;
			this.camera.zoom = 1;
			this.camera.fov = 36;
			this.camera.target = DisplayObject3D.ZERO;
			
			var conpaneLabel:Label = new Label();
			conpaneLabel.htmlText = '<font color="#ffffff" size="12px">カメラ操作パネル</font>';
			conpaneLabel.x = 35;
			conpaneLabel.y = 5;
			this.addChild(conpaneLabel);

			//カメラ左右移動
			var cameraXLabel:Label = new Label();
			cameraXLabel.htmlText = '<font color="#ffffff">X軸移動:</font>';
			cameraXLabel.x = this.sliderLabelMarginX;
			cameraXLabel.y = this.sliderLabelMarginY;
			this.addChild(cameraXLabel);
				
			sliderX = new Slider();
			sliderX.value = this.defaultCameraX;
			sliderX.maximum = 1200;
			sliderX.minimum = -1200;
			sliderX.x = this.sliderMarginX,
			sliderX.y = this.sliderMarginY;
			sliderX.addEventListener(SliderEvent.THUMB_DRAG,cameraMoveX);
			cameraXLabel.addChild(sliderX);
				
			//カメラ上下移動
			var cameraYLabel:Label = new Label();
			cameraYLabel.htmlText = '<font color="#ffffff">Y軸移動:</font>';
			cameraYLabel.x = this.sliderLabelMarginX;
			cameraYLabel.y = cameraXLabel.y + this.sliderLabelMarginY;
			this.addChild(cameraYLabel);
				
			sliderY = new Slider();
			sliderY.value = this.defaultCameraY;
			sliderY.maximum = 1200;
			sliderY.minimum = -1200;
			sliderY.x = this.sliderMarginX,
			sliderY.y = this.sliderMarginY;
			sliderY.addEventListener(SliderEvent.THUMB_DRAG,cameraMoveY);
			cameraYLabel.addChild(sliderY);
				
			//カメラ前後移動
			var cameraZLabel:Label = new Label();
			cameraZLabel.htmlText = '<font color="#ffffff">Z軸移動:</font>';
			cameraZLabel.x = this.sliderLabelMarginX;
			cameraZLabel.y = cameraYLabel.y + this.sliderLabelMarginY;
			this.addChild(cameraZLabel);
				
			sliderZ = new Slider();
			sliderZ.value = this.defaultCameraZ;
			sliderZ.maximum = 500;
			sliderZ.minimum = -500;
			sliderZ.x = this.sliderMarginX,
			sliderZ.y = this.sliderMarginY;
			sliderZ.addEventListener(SliderEvent.THUMB_DRAG,cameraMoveZ);
			cameraZLabel.addChild(sliderZ);	
				
			//リセットボタン
			var resetButton:Button = new Button();
			resetButton.label = "リセット";
			resetButton.x = 35;
			resetButton.y = 130;
			resetButton.addEventListener(MouseEvent.CLICK,resetButtonClick, false, 0, true);
			this.addChild(resetButton);
		}
		
		private function cameraMoveX(event:Event):void
		{
			camera.x = event.target.value;
			//camera.target.x = defaultCameraTargetX + event.target.value;
		}
		
		private function cameraMoveY(event:Event):void
		{
			camera.y = event.target.value;
			//camera.target.y = defaultCameraTargetY + event.target.value;
		}
		
		private function cameraMoveZ(event:Event):void
		{
			camera.z = defaultCameraZ + event.target.value;
			//camera.target.z = defaultCameraTargetZ + event.target.value;
		}
		
		private function resetButtonClick(event:Event):void
		{			
			Tweener.addTween(camera, { x: defaultCameraX, time :0.5 } );
			Tweener.addTween(camera, { y: defaultCameraY, time :0.5 } );
			Tweener.addTween(camera, { z: defaultCameraZ, time :0.5 } );
			
			Tweener.addTween(camera.target, { x: defaultCameraTargetX, time :0.5 } );
			Tweener.addTween(camera.target, { y: defaultCameraTargetY, time :0.5 } );
			Tweener.addTween(camera.target, { z: defaultCameraTargetZ, time :0.5 } );
			
			sliderX.value = 0;
			sliderY.value = 0;
			sliderZ.value = 0;
		}
		
		/*以下 ゲッターとセッター*/
		public function get camera3D():Camera3D
		{
			return camera;
		}
		
	}

}