﻿package object3ds.flashGUI 
{
	import flash.events.Event;
	import flash.events.MouseEvent;
	import fl.controls.Label;
	import fl.controls.Button;
	import fl.controls.Slider;
	import fl.events.SliderEvent;
	
	/*【課題】下記の3つのクラスをDisplayObject3Dに統一する*/
	import org.papervision3d.objects.parsers.DAE;
	import org.papervision3d.objects.DisplayObject3D;
	import object3ds.factoryObject3d.FactoryObject3d;
	
	import caurina.transitions.Tweener; 
	
	/**
	 * ...
	 * @author hagiwara
	 */
	public class Object3dConPane extends conPaneS
	{
		private var object3d:FactoryObject3d;
		
		private var sliderX:Slider;
		private var sliderY:Slider;
		private var sliderZ:Slider;
		
		private var sliderLabelMarginX:int = 10;
		private var sliderLabelMarginY:int = 30;
		private var sliderMarginX:int = 50;
		private var sliderMarginY:int = 7;
		
		public function Object3dConPane(object3d:FactoryObject3d) 
		{
			//オグジェクト３Dのコントロールパネル
			this.object3d = object3d;
			super();
			this.x = this.y = 10;
			
			var conpaneLabel:Label = new Label();
			conpaneLabel.htmlText = '<font color="#ffffff" size="12px">'+object3d.name+'操作パネル</font>';
			conpaneLabel.x = 35;
			conpaneLabel.y = 5;
			this.addChild(conpaneLabel);			
			
			//X軸回転
			var sliderXLabel:Label = new Label();
			sliderXLabel.htmlText = '<font color="#ffffff">X軸回転:</font>';
			sliderXLabel.x = sliderLabelMarginX;
			sliderXLabel.y = 30;
			this.addChild(sliderXLabel);
			
			sliderX = new Slider();
			sliderX.maximum = 360;
			sliderX.minimum = -360;
			sliderX.x = sliderMarginX;
			sliderX.y = sliderMarginY;
			sliderX.addEventListener(SliderEvent.THUMB_DRAG,setRotationX);
			sliderXLabel.addChild(sliderX);
			
			//Y軸回転
			var sliderYLabel:Label = new Label();
			sliderYLabel.htmlText = '<font color="#ffffff">Y軸回転:</font>';
			sliderYLabel.x = sliderLabelMarginX;
			sliderYLabel.y = sliderXLabel.y + sliderLabelMarginY;
			this.addChild(sliderYLabel);
			
			sliderY = new Slider();
			sliderY.maximum = 360;
			sliderY.minimum = -360;
			sliderY.x = sliderMarginX,
			sliderY.y = sliderMarginY;
			sliderY.addEventListener(SliderEvent.THUMB_DRAG,setRotationY);
			sliderYLabel.addChild(sliderY);
			
			//Z軸回転
			var sliderZLabel:Label = new Label();
			sliderZLabel.htmlText = '<font color="#ffffff">Z軸回転:</font>';
			sliderZLabel.x = sliderLabelMarginX;
			sliderZLabel.y = sliderYLabel.y + sliderLabelMarginY;;
			this.addChild(sliderZLabel);
			
			sliderZ = new Slider();
			sliderZ.maximum = 360;
			sliderZ.minimum = -360;
			sliderZ.x = sliderMarginX;
			sliderZ.y = sliderMarginY;
			sliderZ.addEventListener(SliderEvent.THUMB_DRAG,setRotationZ);
			sliderZLabel.addChild(sliderZ);
			
						
			//リセットボタン
			var resetButton:Button = new Button();
			resetButton.label = "リセット";
			resetButton.x = 35;
			resetButton.y = 130;
			resetButton.addEventListener(MouseEvent.CLICK,resetButtonClick, false, 0, true);
			this.addChild(resetButton);
			
		}
		
		private function setRotationX(event:Event):void
		{
			object3d.localRotationX = event.target.value;
			//object3d.rotationX = event.target.value;
		}
		
		private function setRotationY(event:Event):void
		{
			object3d.localRotationY = event.target.value;
			//object3d.rotationY = event.target.value;
		}
		
		private function setRotationZ(event:Event):void
		{
			object3d.localRotationZ = event.target.value * -1;
			//object3d.rotationZ = event.target.value * -1;
		}
		
		private function resetButtonClick(event:Event):void
		{	
			Tweener.addTween(object3d , {x:0,y:0,z:0,rotationX:0,rotationY:0,rotationZ:0, localRotationX:0, localRotationY:0, localRotationZ:0, time :0.5 } );
			
			sliderX.value = 0;
			sliderY.value = 0;
			sliderZ.value = 0;

		}
		
	}

}