﻿package sceneClasses 
{
	import flash.display.Bitmap;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.utils.getDefinitionByName;
	import org.papervision3d.view.Viewport3D;
	import org.papervision3d.render.BasicRenderEngine;
	import org.papervision3d.scenes.Scene3D;
	import org.papervision3d.objects.primitives.Plane;
	import org.papervision3d.materials.WireframeMaterial;
	import org.papervision3d.materials.BitmapFileMaterial;
	import flash.display.BitmapData;
	import org.papervision3d.materials.BitmapMaterial;
	
	import object3ds.ControllObject3d;
	import object3ds.flashGUI.CameraConPane;
	import object3ds.flashGUI.AnimeConPane;
	import object3ds.flashGUI.Object3dConPane;
	import object3ds.factoryObject3d.FactoryObject3d;
	
	/**
	 * ...
	 * @author hagiwara
	 */
	public class Scene01 extends Sprite
	{ 
		private var viewport:Viewport3D;
		private var render:BasicRenderEngine;
		private var scene3D:Scene3D;
		private var controllObject3d:ControllObject3d;
		private var cameraConPane:CameraConPane;		
		private var ground:Plane;
		private var SMSlogo:Plane;
		private var loadingText:TextField;
		
		private var flg:Boolean = false; //true == 準備完了 false == 準備前
		
		//シングルトンInstance
		private static var $instance:Scene01;
		
		public function Scene01(singletonEnforcer:SingletonEnforcer) 
		{
		
		}
		
		public static function getInstance():Scene01
		{
			if (Scene01.$instance == null) {
				$instance = new Scene01(new SingletonEnforcer());
			}
			return Scene01.$instance;
		}
		
		public function prepaer():void
		{
			if (!stage) {
				trace("ステージに配置して下さい");
			}
			
			if (flg != true) {
				//3Dシーン作成
				scene3D = new Scene3D();
				
				//ビューポート
				viewport = new Viewport3D(560, 600);
				stage.addChild(viewport);
				
				//カメラ
				cameraConPane = new CameraConPane();
				stage.addChild(cameraConPane);
				
				//レンダラ
				render = new BasicRenderEngine(); 
				
				//地面
				var groundMaterial:WireframeMaterial = new WireframeMaterial(0xcccccc, 10);
				groundMaterial.oneSide = false;
				ground = new Plane(groundMaterial, 1000, 1000, 5, 5);
				ground.localRotationX = 90;
				ground.y = -600;
				this.scene3D.addChild(ground);
				
				//SMSロゴ
				var className:String = "SMS_logo";
				var textureClass:Class = Class(getDefinitionByName(className));
				
				var SMS_logo_BitmapMaterial = new BitmapMaterial(new textureClass(0,0));
				SMS_logo_BitmapMaterial.oneSide = false;
				SMSlogo = new Plane(SMS_logo_BitmapMaterial, 200, 200, 2, 2);
								
				this.scene3D.addChild(SMSlogo);
				
				//コントロールオブジェクト3D
				controllObject3d =  ControllObject3d.getInstance();
				controllObject3d.addEventListener(FactoryObject3d.COMPLETE_CREATE_OBJECT3D, completeCreatObject)
				controllObject3d.createObject3d();
				
				flg = true;
				trace("準備完了");
			}
			
			var loadingTextFormat:TextFormat = new TextFormat();
			loadingTextFormat.size = 30;
			loadingTextFormat.align = "center"
			
			loadingText = new TextField();
			loadingText.defaultTextFormat = loadingTextFormat;
			loadingText.x = 0;
			loadingText.y = 100;
			loadingText.width = 560;
			loadingText.height = 50;
			loadingText.text = "Now Loading...";
			loadingText.textColor = 0xf4f4f4;
			stage.addChild(loadingText);
		}
		
		public function startLoading():void
		{
			this.addEventListener(Event.ENTER_FRAME, loading);
		}
		
		private function loading(event:Event):void 
		{
			SMSlogo.localRotationY += 20;
			render.renderScene(scene3D, cameraConPane.camera3D, viewport);
		}
		
		private function completeCreatObject(event:Event):void
		{
			scene3D.removeChild(SMSlogo);
			stage.removeChild(loadingText);
			SMSlogo = null;
			loadingText = null;
			this.removeEventListener(Event.ENTER_FRAME, loading);
			
			scene3D.addChild(controllObject3d.object3d);
			stage.addChild(controllObject3d.object3dConPane);
			stage.addChild(controllObject3d.animeConPane);
			this.addEventListener(Event.ENTER_FRAME, rendering);
		}		
		
		private function rendering(event:Event):void 
		{
			render.renderScene(scene3D, cameraConPane.camera3D, viewport);
		}
		
	}//class
}//package

class SingletonEnforcer {
	//シングルトン用のクラス
}